diff --git a/toolkit/crashreporter/google-breakpad/src/tools/mac/crash_report/on_demand_symbol_supplier.h b/toolkit/crashreporter/google-breakpad/src/tools/mac/crash_report/on_demand_symbol_supplier.h
--- a/toolkit/crashreporter/google-breakpad/src/tools/mac/crash_report/on_demand_symbol_supplier.h
+++ b/toolkit/crashreporter/google-breakpad/src/tools/mac/crash_report/on_demand_symbol_supplier.h
@@ -42,30 +42,35 @@ namespace google_breakpad {
 using std::map;
 using std::string;
 class MinidumpModule;
 
 class OnDemandSymbolSupplier : public SymbolSupplier {
  public:
   // |search_dir| is the directory to search for alternative symbols with
   // the same name as the module in the minidump
-  OnDemandSymbolSupplier(const string &search_dir, 
+  OnDemandSymbolSupplier(const string &search_dir,
                          const string &symbol_search_dir);
   virtual ~OnDemandSymbolSupplier() {}
 
   // Returns the path to the symbol file for the given module.
   virtual SymbolResult GetSymbolFile(const CodeModule *module,
                                      const SystemInfo *system_info,
                                      string *symbol_file);
 
+  // Returns the path to the symbol file for the given module.
+  virtual SymbolResult GetSymbolFile(const CodeModule *module,
+                                     const SystemInfo *system_info,
+                                     string *symbol_file,
+                                     string *symbol_data);
  protected:
   // Search directory
   string search_dir_;
   string symbol_search_dir_;
-  
+
   // When we create a symbol file for a module, save the name of the module
   // and the path to that module's symbol file.
   map<string, string> module_file_map_;
 
   // Return the name for |module|  This will be the value used as the key
   // to the |module_file_map_|.
   string GetNameForModule(const CodeModule *module);
 
diff --git a/toolkit/crashreporter/google-breakpad/src/tools/mac/crash_report/on_demand_symbol_supplier.mm b/toolkit/crashreporter/google-breakpad/src/tools/mac/crash_report/on_demand_symbol_supplier.mm
--- a/toolkit/crashreporter/google-breakpad/src/tools/mac/crash_report/on_demand_symbol_supplier.mm
+++ b/toolkit/crashreporter/google-breakpad/src/tools/mac/crash_report/on_demand_symbol_supplier.mm
@@ -25,16 +25,18 @@
 // DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 // THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 // (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 // OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 #include <sys/stat.h>
 #include <map>
 #include <string>
+#include <iostream>
+#include <fstream>
 
 #include "google_breakpad/processor/basic_source_line_resolver.h"
 #include "google_breakpad/processor/minidump.h"
 #include "google_breakpad/processor/system_info.h"
 #include "processor/pathname_stripper.h"
 
 #include "on_demand_symbol_supplier.h"
 #include "dump_syms.h"
@@ -131,16 +133,36 @@ OnDemandSymbolSupplier::GetSymbolFile(co
 
   if (path.empty())
     return NOT_FOUND;
 
   *symbol_file = path;
   return FOUND;
 }
 
+SymbolSupplier::SymbolResult
+OnDemandSymbolSupplier::GetSymbolFile(const CodeModule *module,
+                                      const SystemInfo *system_info,
+                                      string *symbol_file,
+                                      string *symbol_data) {
+  SymbolSupplier::SymbolResult s = GetSymbolFile(module,
+                                                 system_info,
+                                                 symbol_file);
+
+
+  if (s == FOUND) {
+    ifstream in(symbol_file->c_str());
+    getline(in, *symbol_data, std::string::traits_type::to_char_type(
+                std::string::traits_type::eof()));
+    in.close();
+  }
+
+  return s;
+}
+
 string OnDemandSymbolSupplier::GetLocalModulePath(const CodeModule *module) {
   NSFileManager *mgr = [NSFileManager defaultManager];
   const char *moduleStr = module->code_file().c_str();
   NSString *modulePath =
     [mgr stringWithFileSystemRepresentation:moduleStr length:strlen(moduleStr)];
   const char *searchStr = search_dir_.c_str();
   NSString *searchDir =
     [mgr stringWithFileSystemRepresentation:searchStr length:strlen(searchStr)];
diff --git a/toolkit/crashreporter/google-breakpad/src/tools/windows/symupload/symupload.cc b/toolkit/crashreporter/google-breakpad/src/tools/windows/symupload/symupload.cc
--- a/toolkit/crashreporter/google-breakpad/src/tools/windows/symupload/symupload.cc
+++ b/toolkit/crashreporter/google-breakpad/src/tools/windows/symupload/symupload.cc
@@ -126,43 +126,65 @@ static bool DumpSymbolsToTempFile(const 
 
   wchar_t temp_filename[_MAX_PATH];
   if (GetTempFileName(temp_path, L"sym", 0, temp_filename) == 0) {
     return false;
   }
 
   FILE *temp_file = NULL;
 #if _MSC_VER >= 1400  // MSVC 2005/8
-  if (_wfopen_s(&temp_file, temp_filename, L"w") != 0) {
+  if (_wfopen_s(&temp_file, temp_filename, L"w") != 0)
 #else  // _MSC_VER >= 1400
   // _wfopen_s was introduced in MSVC8.  Use _wfopen for earlier environments.
   // Don't use it with MSVC8 and later, because it's deprecated.
-  if (!(temp_file = _wfopen(temp_filename, L"w"))) {
+  if (!(temp_file = _wfopen(temp_filename, L"w")))
 #endif  // _MSC_VER >= 1400
+  {
     return false;
   }
 
   bool success = writer.WriteMap(temp_file);
   fclose(temp_file);
   if (!success) {
     _wunlink(temp_filename);
     return false;
   }
 
   *temp_file_path = temp_filename;
 
   return writer.GetModuleInfo(pdb_info);
 }
 
+void printUsageAndExit() {
+  wprintf(L"Usage: symupload [--timeout NN] <file.exe|file.dll> <symbol upload URL>\n\n");
+  wprintf(L"Timeout is in milliseconds, or can be 0 to be unlimited\n\n");
+  wprintf(L"Example:\n\n\tsymupload.exe --timeout 0 chrome.dll http://no.free.symbol.server.for.you\n");
+  exit(0);
+}
 int wmain(int argc, wchar_t *argv[]) {
-  if (argc < 3) {
-    wprintf(L"Usage: %s <file.exe|file.dll> <symbol upload URL>\n", argv[0]);
-    return 0;
+  if ((argc != 3) &&
+      (argc != 5)) {
+    printUsageAndExit();
   }
-  const wchar_t *module = argv[1], *url = argv[2];
+
+  const wchar_t *module, *url;
+  int timeout = -1;
+  if (argc == 3) {
+    module = argv[1];
+    url = argv[2];
+  } else {
+    // check for timeout flag
+    if (!wcscmp(L"--timeout", argv[1])) {
+      timeout  = _wtoi(argv[2]);
+      module = argv[3];
+      url = argv[4];
+    } else {
+      printUsageAndExit();
+    }
+  }
 
   wstring symbol_file;
   PDBModuleInfo pdb_info;
   if (!DumpSymbolsToTempFile(module, &symbol_file, &pdb_info)) {
     fwprintf(stderr, L"Could not get symbol data from %s\n", module);
     return 1;
   }
 
@@ -181,16 +203,17 @@ int wmain(int argc, wchar_t *argv[]) {
   if (GetFileVersionString(module, &file_version)) {
     parameters[L"version"] = file_version;
   } else {
     fwprintf(stderr, L"Warning: Could not get file version for %s\n", module);
   }
 
   bool success = HTTPUpload::SendRequest(url, parameters,
                                          symbol_file, L"symbol_file",
+										 timeout == -1 ? NULL : &timeout,
                                          NULL, NULL);
   _wunlink(symbol_file.c_str());
 
   if (!success) {
     fwprintf(stderr, L"Symbol file upload failed\n");
     return 1;
   }
 
diff --git a/toolkit/crashreporter/test/unit/test_crashreporter_crash_profile_lock.js b/toolkit/crashreporter/test/unit/test_crashreporter_crash_profile_lock.js
new file mode 100644
--- /dev/null
+++ b/toolkit/crashreporter/test/unit/test_crashreporter_crash_profile_lock.js
@@ -0,0 +1,27 @@
+function run_test()
+{
+  if (!("@mozilla.org/toolkit/crash-reporter;1" in Components.classes)) {
+    dump("INFO | test_crashreporter.js | Can't test crashreporter in a non-libxul build.\n");
+    return;
+  }
+
+  // lock a profile directory, crash, and ensure that
+  // the profile lock signal handler doesn't interfere with
+  // writing a minidump
+  do_crash(function() {
+             let env = Components.classes["@mozilla.org/process/environment;1"]
+               .getService(Components.interfaces.nsIEnvironment);
+             // the python harness sets this in the environment for us
+             let profd = env.get("XPCSHELL_TEST_PROFILE_DIR");
+             let dir = Components.classes["@mozilla.org/file/local;1"]
+               .createInstance(Components.interfaces.nsILocalFile);
+             dir.initWithPath(profd);
+             let mycrasher = Components.classes["@mozilla.org/testcrasher;1"].createInstance(Components.interfaces.nsITestCrasher);
+             let lock = mycrasher.lockDir(dir);
+             // when we crash, the lock file should be cleaned up
+           },
+           function(mdump, extra) {
+             // if we got here, we have a minidump, so that's all we wanted
+             do_check_true(true);
+           });
+}
diff --git a/toolkit/toolkit-makefiles.sh b/toolkit/toolkit-makefiles.sh
--- a/toolkit/toolkit-makefiles.sh
+++ b/toolkit/toolkit-makefiles.sh
@@ -690,16 +690,17 @@ MAKEFILES_embedding="
 
 MAKEFILES_xulapp="
   toolkit/Makefile
   toolkit/library/Makefile
   toolkit/crashreporter/Makefile
   toolkit/crashreporter/client/Makefile
   toolkit/crashreporter/google-breakpad/src/client/Makefile
   toolkit/crashreporter/google-breakpad/src/client/linux/handler/Makefile
+  toolkit/crashreporter/google-breakpad/src/client/linux/minidump_writer/Makefile
   toolkit/crashreporter/google-breakpad/src/client/mac/handler/Makefile
   toolkit/crashreporter/google-breakpad/src/client/solaris/handler/Makefile
   toolkit/crashreporter/google-breakpad/src/client/windows/crash_generation/Makefile
   toolkit/crashreporter/google-breakpad/src/client/windows/handler/Makefile
   toolkit/crashreporter/google-breakpad/src/client/windows/sender/Makefile
   toolkit/crashreporter/google-breakpad/src/common/Makefile
   toolkit/crashreporter/google-breakpad/src/common/linux/Makefile
   toolkit/crashreporter/google-breakpad/src/common/mac/Makefile
